﻿#задаем значения параметров
$loc_lib_name = "_Локальный компьютер"
$loc_dirs = "Мои данные"
$net_lib_name = "_Сетевое хранилище"
$net_dirs = "contacts", "desktop", "documents", "downloads", "favorites", "links", "music", "pictures", "saved games", "searches", "videos"
$rdr_root = "\\domain.local\dfs\redirected"

#задаем значения переменных
$libs_path = "$env:APPDATA\Microsoft\Windows\Libraries"
$loc_lib = "$libs_path\$loc_lib_name.library-ms"
$loc_root = "$env:USERPROFILE"
$libs_path = "$env:APPDATA\Microsoft\Windows\Libraries"
$net_lib = "$libs_path\$net_lib_name.library-ms"
$net_root = $rdr_root + "\" + $env:USERNAME

#создаем локальные папки для добавления в локальную библиотеку (если они еще не были созданы)
foreach ($loc_dir in $loc_dirs)
{
    $loc_path = $loc_root + "\" + $loc_dir
    if (!(Test-Path -Path $loc_path))
    {
        New-Item -Type Directory -Path $loc_path
    }    
}

#создаем локальную библиотеку (если она еще не была создана)
if (!(Test-Path -Path $loc_lib))
{
    $xml_doc = New-Object System.XML.XMLDocument
    $xml_dec = $xml_doc.CreateXmlDeclaration("1.0","UTF-8",$null)
    $xml_doc.AppendChild($xml_dec)
    $lib_desc = $xml_doc.CreateElement("libraryDescription")
    $xml_doc.AppendChild($lib_desc)
    $lib_desc.SetAttribute("xmlns","http://schemas.microsoft.com/windows/2009/library")
    $ver = $xml_doc.CreateElement("version")
    $ver.InnerText = 1
    $lib_desc.AppendChild($ver)
    $pin = $xml_doc.CreateElement("isLibraryPinned")
    $pin.InnerText = "true"
    $lib_desc.AppendChild($pin)
    $src_con_desc_lst = $xml_doc.CreateElement("searchConnectorDescriptionList")
    $lib_desc.AppendChild($src_con_desc_lst)
    foreach ($loc_dir in $loc_dirs)
    {    
        $src_con_desc = $xml_doc.CreateElement("searchConnectorDescription")
        $src_con_desc_lst.AppendChild($src_con_desc)
        $smp_loc = $xml_doc.CreateElement("simpleLocation")
        $src_con_desc.AppendChild($smp_loc)
        $url = $xml_doc.CreateElement("url")
        $url.InnerText = $loc_root + "\" + $loc_dir
        $smp_loc.AppendChild($url)
    }
    $xml_doc.Save($loc_lib)
}

#создаем сетевую библиотеку (если она еще не была создана)
if (!(Test-Path -Path $net_lib))
{
    $xml_doc = New-Object System.XML.XMLDocument
    $xml_dec = $xml_doc.CreateXmlDeclaration("1.0","UTF-8",$null)
    $xml_doc.AppendChild($xml_dec)
    $lib_desc = $xml_doc.CreateElement("libraryDescription")
    $xml_doc.AppendChild($lib_desc)
    $lib_desc.SetAttribute("xmlns","http://schemas.microsoft.com/windows/2009/library")
    $ver = $xml_doc.CreateElement("version")
    $ver.InnerText = 1
    $lib_desc.AppendChild($ver)
    $pin = $xml_doc.CreateElement("isLibraryPinned")
    $pin.InnerText = "true"
    $lib_desc.AppendChild($pin)
    $src_con_desc_lst = $xml_doc.CreateElement("searchConnectorDescriptionList")
    $lib_desc.AppendChild($src_con_desc_lst)
    foreach ($net_dir in $net_dirs)
    {    
        $src_con_desc = $xml_doc.CreateElement("searchConnectorDescription")
        $src_con_desc_lst.AppendChild($src_con_desc)
        $smp_loc = $xml_doc.CreateElement("simpleLocation")
        $src_con_desc.AppendChild($smp_loc)
        $url = $xml_doc.CreateElement("url")
        $url.InnerText = $net_root + "\" + $net_dir
        $smp_loc.AppendChild($url)
    }
    $xml_doc.Save($net_lib)
}
